# Next Template

## Folders

- \__tests__: Test files to test webpage or single components
- docker: Docker files to launch in a Container
- public: Static files
- src: Source folder
  - components: Contains your React Components
  - libs: Contains your libs or utility files
  - models: Contains your Models
  - pages: Contains your NextJS pages
  - styl: Contains your Stylus files
    - modules: Stylus module location

## TODO list

### Typescript/Javascript

- [x] Support Typescript
- [x] Support Javascript
- [x] Support Javascript files Linting
- [x] Unit Testing
- [ ] Lint unit tests

### Stylus

- [x] Support Stylus files
- [ ] Support PurgeCSS
- [ ] Support typed stylus files

## Dependencies

- @dzeio/components: Graphic components
- @dzeio/config: Configuration files in a NPM lib
- critters: next dependency
- lucide-react: @dzeio/components dependency
- next: Nextjs
- next-compose-plugins: Better plugin formatting in config
- next-purgecss: PurgeCSS Plugin in config
- next-pre-css: Allow to compile Stylus for NextJS
- next-seo: SEO for nextjs
- react: React
- react-dom: React DOM (React Dependency)
- stylus: next-pre-css dependency
- stylus-loader: next-pre-css dependency
- typescript: Typescript
- webpack: Webpack

## Dev Dependencies

- @babel/core: Tests Dependency
- @next/eslint-plugin-next: nextjs dependency for eslint
- @types/node: Typescript Typing
- @types/react: Typescript Typing
- @typescript-eslint/eslint-plugin: ESLint Typescript Plugin
- @typescript-eslint/parser: ESLint Typescript parser
- eslint: ESLint
- eslint-config-next: ESLint Next Plugin
- eslint-plugin-react: ESLint React Plugin
- jest: Jest tessting framework
- react-test-renderer: Test React components
